# encoding: utf-8
#
# クレジットカード決済 キャンセル要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
# 対象の取引IDを指定します
@order_id = "change_order_id"

#-------------------------------------------------------
# 支払金額
# 指定無しの場合全額取消
#-------------------------------------------------------
@amount = "5"


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::CardCancelRequestDto.new
@request_data.order_id = @order_id.to_s
@request_data.amount = @amount.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Card Number]: #{@response_data.req_card_number}"
  puts "[Center Reference Number]: #{@response_data.center_reference_number}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Card Number]: #{@response_data.req_card_number}"
  puts "[Center Reference Number]: #{@response_data.center_reference_number}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Card Number]: #{@response_data.req_card_number}"
  puts "[Center Reference Number]: #{@response_data.center_reference_number}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
