# encoding: utf-8
#
# PayNowId 会員復活要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 会員ID
#-------------------------------------------------------
@account_id = "TestAccountId"

#-------------------------------------------------------
# 入会年月日
#-------------------------------------------------------
@create_date = (Time.now + 24*60*60*10).strftime("%Y%m%d").to_s


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::AccountRestoreRequestDto.new
@request_data.account_id = @account_id.to_s
@request_data.create_date = @create_date.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg

unless @response_data.pay_now_id_response.nil?
  pay_now_id_response = @response_data.pay_now_id_response
  #
  # PayNowIDステータス取得
  #
  @pay_now_id_status = pay_now_id_response.status
  #
  # PayNowID処理番号取得
  #
  @pay_now_id_proc_id = pay_now_id_response.process_id
end


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @pay_now_id_status
  puts "...Transaction Successfully Complete"
  puts "[PayNowId Status]: #{@pay_now_id_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[PayNowId ProcessId]: #{@pay_now_id_proc_id}"
end
# 失敗
if "failure" == @pay_now_id_status
  puts "...Transaction Failure"
  puts "[PayNowId Status]: #{@pay_now_id_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[PayNowId ProcessId]: #{@pay_now_id_proc_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
