# encoding: utf-8
#
# 楽天ID決済再与信 要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
@order_id = "dummy" + Time.now.to_i.to_s

#-------------------------------------------------------
# 元取引ID
#-------------------------------------------------------
@original_order_id = ""

#-------------------------------------------------------
# 決済金額
#-------------------------------------------------------
@amount = "100"

#-------------------------------------------------------
# 与信同時売上フラグ
#-------------------------------------------------------
@with_capture = "false"

#-------------------------------------------------------
# 商品ID
#-------------------------------------------------------
@item_id = "123456"

#-------------------------------------------------------
# 商品名
#-------------------------------------------------------
@item_name = "テスト商品"

#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::RakutenReAuthorizeRequestDto.new
@request_data.order_id= @order_id.to_s
@request_data.original_order_id= @original_order_id.to_s
@request_data.amount= @amount.to_s
@request_data.with_capture= @with_capture.to_s
@request_data.item_id= @item_id.to_s
@request_data.item_name= @item_name.to_s

#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg

#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Original Order ID]: #{@response_data.original_order_id}"
  puts "[Rakuten Order ID]: #{@response_data.rakuten_order_id}"
  puts "[Gateway Order ID]: #{@response_data.gateway_order_id}"
  puts "[Rakuten Consent Order ID]: #{@response_data.rakuten_consent_order_id}"
  puts "[Customer ID]: #{@response_data.customer_id}"
  puts "[Used Point]: #{@response_data.used_point}"
  puts "[Card Brand]: #{@response_data.card_brand}"
  puts "[Card Last4]: #{@response_data.card_last4}"
  puts "[Card Installments]: #{@response_data.card_installments}"
  puts "[Card Cvc]: #{@response_data.card_cvc}"
  puts "[Card 3ds]: #{@response_data.card3ds}"
  puts "[Transaction Datetime]: #{@response_data.transaction_datetime}"
  puts "[Cancel Expiration Time]: #{@response_data.cancel_expiration_time}"
  puts "[Capture Expiration Time]: #{@response_data.capture_expiration_time}"
  puts "[Update Expiration Time]: #{@response_data.update_expiration_time}"
  puts "[Extend Auth Expiration Time]: #{@response_data.extend_auth_expiration_time}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
