# encoding: utf-8
#
# 楽天ID決済売上 要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID(与信時に利用したものを設定してください)
#-------------------------------------------------------
@order_id = ""

#-------------------------------------------------------
# 金額
#-------------------------------------------------------
@amount = "100"

#-------------------------------------------------------
# 与信延長フラグ
#-------------------------------------------------------
@auth_extension_flag = "true"


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::RakutenUpdateAuthorizeRequestDto.new
@request_data.order_id= @order_id.to_s
@request_data.amount= @amount.to_s
@request_data.auth_extension_flag= @auth_extension_flag.to_s

#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Transaction Datetime]: #{@response_data.transaction_datetime}"
  puts "[Rakuten Order Id]: #{@response_data.rakuten_order_id}"
  puts "[Gateway Order Id]: #{@response_data.gateway_order_id}"
  puts "[Used Point]: #{@response_data.used_point}"
  puts "[Cancel Expiration Time]: #{@response_data.cancel_expiration_time}"
  puts "[Capture Expiration Time]: #{@response_data.capture_expiration_time}"
  puts "[Update Expiration Time]: #{@response_data.update_expiration_time}"
  puts "[Extend Auth Expiration Time]: #{@response_data.extend_auth_expiration_time}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
