# encoding: utf-8
#
# リクルートかんたん支払申込 要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
@order_id = "dummy" + Time.now.to_i.to_s

#-------------------------------------------------------
# 決済金額
#-------------------------------------------------------
@amount = "100"

#-------------------------------------------------------
# 与信同時売上フラグ
#-------------------------------------------------------
@with_capture = "false"

#-------------------------------------------------------
# 商品番号
#-------------------------------------------------------
@item_id = "123456"

#-------------------------------------------------------
# 商品名
#-------------------------------------------------------
@item_name = "テスト商品"

#-------------------------------------------------------
# 決済完了時URL
#-------------------------------------------------------
#@success_url = ""

#-------------------------------------------------------
# 決済キャンセル時URL
#-------------------------------------------------------
#@cancel_url = ""

#-------------------------------------------------------
# 決済エラー時URL
#-------------------------------------------------------
#@error_url = ""

#-------------------------------------------------------
# プッシュURL
#-------------------------------------------------------
#@push_url = ""

#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::RecruitAuthorizeRequestDto.new
@request_data.order_id= @order_id.to_s
@request_data.with_capture= @with_capture.to_s
@request_data.amount= @amount.to_s

@request_data.item_id= @item_id.to_s
@request_data.item_name= @item_name.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg

#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
