# encoding: utf-8
#
# 永久不滅ポイント(永久不滅ウォレット) 売上要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
# 対象の取引IDを指定します
@order_id = "change_order_id"

#-------------------------------------------------------
# 決済金額
#-------------------------------------------------------
@amount = "100"

#-------------------------------------------------------
# 永久不滅ウォレット決済金額
#-------------------------------------------------------
@wallet_amount = "70"

#-------------------------------------------------------
# カード決済金額
#-------------------------------------------------------
@card_amount = "30"

#-------------------------------------------------------
# トークン
#-------------------------------------------------------
@token = "0a812412-682c-4dad-8a5d-720caf23bca0"

#-------------------------------------------------------
# カード取引ID
#-------------------------------------------------------
@card_order_id = ""

#-------------------------------------------------------
# カード売上フラグ
#-------------------------------------------------------
@with_capture = "true"


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::SaisonCaptureRequestDto.new
@request_data.order_id = @order_id.to_s
@request_data.amount = @amount.to_s
@request_data.wallet_amount = @wallet_amount.to_s
@request_data.card_amount = @card_amount.to_s
@request_data.token = @token.to_s
@request_data.card_order_id = @card_order_id.to_s
@request_data.with_capture = @with_capture.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Res Auth Code]: #{@response_data.res_auth_code}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Res Auth Code]: #{@response_data.res_auth_code}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
