# encoding: utf-8
#
# 銀行振込 決済要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID(自動取得)
#-------------------------------------------------------
@order_id = "dummy" + Time.now.to_i.to_s

#-------------------------------------------------------
# 決済金額
#-------------------------------------------------------
@amount = "10"

#-------------------------------------------------------
# 口座振込人名
#-------------------------------------------------------
@entry_transfer_name = "テストタロウ"

#-------------------------------------------------------
# 口座振込番号
#-------------------------------------------------------
@entry_transfer_number = "００００１"

#-------------------------------------------------------
# 振込期限(YYYYMMDD)
#-------------------------------------------------------
@transfer_expired_date = ""

#-------------------------------------------------------
# 口座管理方式
# 実口座 : Veritrans::Tercerog::Mdk::MdkConst::ACCOUNT_MANAGE_TYPE_REAL
# バーチャル口座 : Veritrans::Tercerog::Mdk::MdkConst::ACCOUNT_MANAGE_TYPE_VIRTUAL
#-------------------------------------------------------
@account_manage_type = Veritrans::Tercerog::Mdk::MdkConst::ACCOUNT_MANAGE_TYPE_REAL

#-------------------------------------------------------
# 支店コード(口座管理方式がバーチャル口座のみ設定)
#-------------------------------------------------------
@branch_code = ""

#-------------------------------------------------------
# 口座番号(口座管理方式がバーチャル口座のみ設定)
#-------------------------------------------------------
@account_number = ""

#-------------------------------------------------------
# サービスオプションタイプ
# りそな : Veritrans::Tercerog::Mdk::MdkConst::VACC_RESONA
#-------------------------------------------------------
@service_option_type = Veritrans::Tercerog::Mdk::MdkConst::VACC_RESONA


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::VirtualaccAuthorizeRequestDto.new
@request_data.order_id= @order_id.to_s
@request_data.amount= @amount.to_s
@request_data.entry_transfer_name= @entry_transfer_name.to_s
@request_data.entry_transfer_number= @entry_transfer_number.to_s
@request_data.transfer_expired_date= @transfer_expired_date.to_s
@request_data.account_manage_type= @account_manage_type.to_s
@request_data.branch_code= @branch_code.to_s
@request_data.account_number= @account_number.to_s
@request_data.service_option_type= @service_option_type.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg

#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Transfer Name]: #{@response_data.transfer_name}"
  puts "[Bank Name]: #{@response_data.bank_name}"
  puts "[Bank Code]: #{@response_data.bank_code}"
  puts "[Branch Name]: #{@response_data.branch_name}"
  puts "[Branch Code]: #{@response_data.branch_code}"
  puts "[Account Type]: #{@response_data.account_type}"
  puts "[Account Number]: #{@response_data.account_number}"
  puts "[Account Name]: #{@response_data.account_name}"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
