# encoding: utf-8
#
# 銀行振込 入金要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID(決済請求に利用したものを設定して下さい)
#-------------------------------------------------------
@order_id = ""

#-------------------------------------------------------
# 入金金額
#-------------------------------------------------------
@amount = ""

#-------------------------------------------------------
# 入金日(YYYYMMDD)
#-------------------------------------------------------
@deposit_date = ""

#-------------------------------------------------------
# 振込人名
#-------------------------------------------------------
@transfer_name = "テストフリコミタロウ"

#-------------------------------------------------------
# 消込フラグ
# 消込しない : Veritrans::Tercerog::Mdk::MdkConst::WITH_RECONCILE_NOT or 未指定
# 消込(強制) : Veritrans::Tercerog::Mdk::MdkConst::WITH_RECONCILE_FORCE
# 消込(自動) : Veritrans::Tercerog::Mdk::MdkConst::WITH_RECONCILE_AUTO
#-------------------------------------------------------
@with_reconcile = ""

#-------------------------------------------------------
# 登録方法
# 手動 : Veritrans::Tercerog::Mdk::MdkConst::REGISTRATION_METHOD_MANUAL or 未指定
# 自動 : Veritrans::Tercerog::Mdk::MdkConst::REGISTRATION_METHOD_AUTO
#-------------------------------------------------------
@registration_method = ""

#-------------------------------------------------------
# サービスオプションタイプ
# りそな : Veritrans::Tercerog::Mdk::MdkConst::VACC_RESONA
#-------------------------------------------------------
@service_option_type = Veritrans::Tercerog::Mdk::MdkConst::VACC_RESONA


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::VirtualaccDepositEntryRequestDto.new
@request_data.order_id= @order_id.to_s
@request_data.amount= @amount.to_s
@request_data.deposit_date= @deposit_date.to_s
@request_data.transfer_name= @transfer_name.to_s
@request_data.with_reconcile= @with_reconcile.to_s
@request_data.registration_method= @registration_method.to_s
@request_data.service_option_type= @service_option_type.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Total Deposit Amount]: #{@response_data.total_deposit_amount}"
  puts "[Deposit ID]: #{@response_data.deposit_id}"
  puts "[Order Status]: #{@response_data.order_status}"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
