# encoding: utf-8
#
# 銀行振込 入金取消要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID(入金請求時に利用したものを設定して下さい)
#-------------------------------------------------------
@order_id = ""

#-------------------------------------------------------
# 入金ID(入金請求時に受け取ったものを設定して下さい)
#-------------------------------------------------------
@deposit_id = ""

#-------------------------------------------------------
# サービスオプションタイプ
# りそな : Veritrans::Tercerog::Mdk::MdkConst::VACC_RESONA
#-------------------------------------------------------
@service_option_type = Veritrans::Tercerog::Mdk::MdkConst::VACC_RESONA


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::VirtualaccDepositReverseRequestDto.new
@request_data.order_id= @order_id.to_s
@request_data.deposit_id= @deposit_id.to_s
@request_data.service_option_type= @service_option_type.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Total Deposit Amount]: #{@response_data.total_deposit_amount}"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
