# -*- encoding: utf-8 -*-
class Web::Bank::AuthorizeController < ApplicationController

  skip_before_action :verify_authenticity_token

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id = "dummy" + Time.now.to_i.to_s
    @amount = params[:price].to_s
  end


  #-------------------------------------------------------------------------
  # 銀行決済要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 決済方式
    @service_option_type = params[:service_option_type]
    # 取引ID
    @order_id = params[:order_id]
    # 決済金額
    @amount = params[:amount]
    # 姓
    @name1 = params[:name1]
    # 名
    @name2 = params[:name2]
    # カナ（姓）
    @kana1 = params[:kana1]
    # カナ（名）
    @kana2 = params[:kana2]
    # 支払期限
    @pay_limit = params[:pay_limit]
    # プッシュURL
    @push_url = params[:push_url]
    # 請求内容
    @contents = params[:contents]
    # 請求内容カナ
    @contents_kana = params[:contents_kana]


    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end


    #==========================================================================
    # 必須パラメータ値チェック
    #==========================================================================
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @amount == ""
      @error_message = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @name1 == ""
      @error_message = "<font color='#ff0000'><b>必須項目：姓が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @kana1 == ""
      @error_message = "<font color='#ff0000'><b>必須項目：カナ（姓）が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @pay_limit == ""
      @error_message = "<font color='#ff0000'><b>必須項目：支払期限が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @contents == ""
      @error_message = "<font color='#ff0000'><b>必須項目：請求内容（漢字）が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @contents_kana == ""
      @error_message = "<font color='#ff0000'><b>必須項目：請求内容（カナ）が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample

    #==========================================================================
    # 要求DTOを生成し、値を設定します。
    #==========================================================================
    req = Veritrans::Tercerog::Mdk::BankAuthorizeRequestDto.new
    req.service_option_type = @service_option_type
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    req.name1 = @name1.to_s
    req.name2 = @name2.to_s unless @name2 == ""
    req.kana1 = @kana1.to_s
    req.kana2 = @kana2.to_s unless @kana2 == ""
    req.pay_limit = @pay_limit.to_s
    req.push_url = @push_url.to_s
    req.contents = @contents.to_s
    req.contents_kana = @contents_kana.to_s

    if @service_option_type == "netbank-pc"
      # ネットバンク決済(PC)の場合にのみ"決済結果戻り先URL"を設定可能
      req.term_url = config["Bank"]["term_url"]
    end


    #==========================================================================
    # コマンドを実行し、応答DTOを取得します。
    #==========================================================================
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

    @org_number = res.shuno_kikan_no
    @customer_number = res.customer_no
    @confirm_number  = res.confirm_no
    @uri = res.url

    @bill_pattern = res.bill_pattern
    @bill = res.bill
  end

end
