# -*- encoding: utf-8 -*-
class Web::Carrier::AuthorizeController < Web::Carrier::AbstractAuthorizeController

  # レスポンスコンテンツをShift-JISで返さなければならない場合の対応
  after_action :check_to_sjis

  #-------------------------------------------------------------------------
  # ドコモとソフトバンクまとめて支払い(B)では、SJISにする必要がある
  # after_action は render の後に呼び出される
  def check_to_sjis
    puts "===== start check_to_sjis ====="
    if @service_option_type == Veritrans::Tercerog::Mdk::MdkConst::CARRIER_DOCOMO or
       @service_option_type == Veritrans::Tercerog::Mdk::MdkConst::CARRIER_SB_KTAI
      puts "===== call to_sjis [" + @service_option_type + "]====="
      to_sjis
    end
  end

  #-------------------------------------------------------------------------
  # see AbstractAuthorizeController
  def get_config_suffix
    return ""
  end

  #-------------------------------------------------------------------------
  # see AbstractAuthorizeController: モバイルのときは true を返す
  def is_no_header_footer
    return "false"
  end

  #-------------------------------------------------------------------------
  # action index のときのデフォルト値を設定
  # PC版では特に何もせず
  def set_my_default
    # no process
  end
end
