# -*- encoding: utf-8 -*-
class Web::Carrier::CancelController < ApplicationController

  #-------------------------------------------------------------------------
  # キャリア決済 取消要求サンプル
  #-------------------------------------------------------------------------
  def execute

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # キャリア選択
    @service_option_type = params[:service_option_type]
    # 課金取消月(YYYYMMDD)
    @cancel_month = params[:cancel_month]
    # 金額
    @amount = params[:amount]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::CarrierCancelRequestDto.new
    req.order_id = @order_id.to_s
    req.service_option_type = @service_option_type.to_s
    req.cancel_month = @cancel_month unless @cancel_month.nil?
    req.amount = @amount unless @amount.nil?


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @balance = res.balance
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @cancel_datetime = res.cancel_datetime

  end

end
