# -*- encoding: utf-8 -*-
class Web::Carrier::ReAuthorizeController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id = "dummy" + Time.now.to_i.to_s
  end

  #-------------------------------------------------------------------------
  # キャリア決済 限度額確保要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # キャリア
    @service_option_type = params[:service_option_type]
    # 取引ID
    @order_id = params[:order_id]
    # 元取引ID
    @original_order_id = params[:original_order_id]
    # 決済金額
    @amount = params[:amount]
    # 与信方法
    @with_capture = params[:with_capture]
    if @with_capture == "1"
      @is_with_capture = "true"
    else
      @is_with_capture = "false"
    end


    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message += "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/>"
    end
    if @original_order_id == ""
      @error_message += "<font color='#ff0000'><b>必須項目：元取引IDが指定されていません</b></font><br/>"
    end
    if @amount == ""
      @error_message += "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/>"
    end
    if @error_message != ""
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::CarrierReAuthorizeRequestDto.new
    req.service_option_type = @service_option_type.to_s
    req.order_id = @order_id.to_s
    req.original_order_id = @original_order_id.to_s
    req.amount = @amount.to_s
    req.with_capture = @is_with_capture.to_s


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

  end
end
