# -*- encoding: utf-8 -*-
class Web::Cvs::AuthorizeController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id = "dummy" + Time.now.to_i.to_s
    @amount = params[:price].to_s
  end

  #-------------------------------------------------------------------------
  # コンビニ決済要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # コンビニタイプ
    @service_option_type = params[:service_option_type]
    # 取引ID
    @order_id = params[:order_id]
    # 決済金額
    @amount = params[:amount]
    # 氏名1（姓）
    @name1 = params[:name1]
    # 氏名2(名)
    @name2 = params[:name2]
    # 電話番号
    @tel_no = params[:tel_no]
    # 支払期限
    @pay_limit = params[:pay_limit]
    # 支払期限時分
    @pay_limit_hhmm = params[:pay_limit_hhmm]
    # プッシュURL
    @push_url = params[:push_url]
    # 払込票URL
    @haraikomi_url ||= ''


    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @amount == ""
      @error_message = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @name1 == ""
      @error_message = "<font color='#ff0000'><b>必須項目：姓が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @name2 == ""
      @error_message = "<font color='#ff0000'><b>必須項目：名が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @tel_no == ""
      @error_message = "<font color='#ff0000'><b>必須項目：電話番号が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @pay_limit == ""
      @error_message = "<font color='#ff0000'><b>必須項目：支払期限が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::CvsAuthorizeRequestDto.new
    req.service_option_type = @service_option_type
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    req.name1 = @name1.to_s
    req.name2 = @name2.to_s
    req.tel_no = @tel_no.to_s
    req.pay_limit = @pay_limit.to_s
    req.pay_limit_hhmm = @pay_limit_hhmm.to_s
    req.push_url = @push_url.to_s
    # 現在はリザーブパラメータのため無条件に "0" を設定してください。(2010.05.22)
    req.payment_type = "0"


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

    @receipt_no = res.receipt_no
    @haraikomi_url = res.haraikomi_url
  end

end
