# -*- encoding: utf-8 -*-
class Web::Em::CancelController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
  end

  #-------------------------------------------------------------------------
  # 電子マネー取消サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 決済方式
    @service_option_type = params[:service_option_type]
    # 取引ID
    @order_id = params[:order_id]
    # オーダー種別
    @order_kind = params[:order_kind]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @service_option_type == "tcc-redirect"
      if @order_kind != ""
        @error_message = "<font color='#ff0000'><b>必須項目：対象取引種別は指定できません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    else
      if @order_kind == ""
        @error_message = "<font color='#ff0000'><b>必須項目：対象取引種別が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::EmCancelRequestDto.new
    req.service_option_type = @service_option_type
    req.order_id = @order_id.to_s
    req.order_kind = @order_kind.to_s


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
  end
end
