# -*- encoding: utf-8 -*-
class Web::Em::ReAuthorizeController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
  end

  #-------------------------------------------------------------------------
  # 電子マネー決済要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 決済方式
    @service_option_type = params[:service_option_type]
    # 取引ID
    @order_id = params[:order_id]
    # 復旧アプリケーション起動URL
    @re_auth_app_url ||= ''

    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::EmReAuthorizeRequestDto.new
    req.service_option_type = @service_option_type
    req.order_id = @order_id.to_s

    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample
    req.re_authorize_redirection_url = config["EM"]["tcc.re_authorize_redirection_url"].to_s

    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    if "success" == res.mstatus
      # 成功した場合はリダイレクト
      redirect_to res.re_auth_app_url, :status => 301

    else
      #--------------------------------------------------------------------------
      # 結果画面に表示します。
      #--------------------------------------------------------------------------
      @result_order_id = res.order_id
      @mstatus = res.mstatus
      @v_result_code = res.v_result_code
      @merr_msg = res.merr_msg

      @re_auth_app_url = res.re_auth_app_url
    end
  end
end
