# -*- encoding: utf-8 -*-
class Web::Masterpass::LoginController < ApplicationController

  # set_dummy_request を実行する
  # after_action では render の後に実行されるため
  before_action :set_dummy_request

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id     = "dummy" + Time.now.to_i.to_s
    @quantity1    = params[:quantity1].to_s
    @value1       = params[:value1].to_s
    @description1 = params[:description1].to_s

    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample

    #各種URLを取得
    @success_url = config["Masterpass"]["success_url"]
    @cancel_url  = config["Masterpass"]["cancel_url"]
    @error_url   = config["Masterpass"]["error_url"]

  end

  #-------------------------------------------------------------------------
  # before_action で実行されるメソッド
  def set_dummy_request
    # ダミーモード判定
    mdk_config = Veritrans::Tercerog::Mdk::MdkConfig.instance
    @dummy_request = mdk_config[:DUMMY_REQUEST]
  end

  #-------------------------------------------------------------------------
  # MasterPass 申込要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 商品番号
    @item_id = params[:item_id]
    if @item_id.nil?
      @item_id = ""
    end
    # 配送先抑止フラグ
    @suppress_shipping_address = params[:suppress_shipping_address]
    # 配送先許可エリア
    @shipping_location_profile = params[:shipping_location_profile]
    #決済申込完了時URL
    @success_url = params[:success_url]
    #決済申込キャンセル時URL
    @cancel_url = params[:cancel_url]
    #決済申込エラー時URL
    @error_url = params[:error_url]

    # 表示用商品説明1
    @description1 = params[:description1]
    # 表示用商品数量1
    @quantity1    = params[:quantity1]
    # 表示用商品金額1
    @value1       = params[:value1]
    # 表示用商品イメージURL1
    @image_url1   = params[:image_url1]
    if @image_url1.nil?
      @image_url1 = ""
    end
    # 表示用商品説明2
    @description2 = params[:description2]
    # 表示用商品数量2
    @quantity2    = params[:quantity2]
    # 表示用商品金額2
    @value2       = params[:value2]
    # 表示用商品イメージURL2
    @image_url2   = params[:image_url2]
    if @image_url2.nil?
      @image_url2 = ""
    end
    # 表示用商品説明3
    @description3 = params[:description3]
    # 表示用商品数量3
    @quantity3    = params[:quantity3]
    # 表示用商品金額3
    @value3       = params[:value3]
    # 表示用商品イメージURL3
    @image_url3   = params[:image_url3]
    if @image_url3.nil?
      @image_url3 = ""
    end
    # 表示用商品説明4
    @description4 = params[:description4]
    # 表示用商品数量4
    @quantity4    = params[:quantity4]
    # 表示用商品金額4
    @value4       = params[:value4]
    # 表示用商品イメージURL4
    @image_url4   = params[:image_url4]
    if @image_url4.nil?
      @image_url4 = ""
    end
    # 表示用商品説明5
    @description5 = params[:description5]
    # 表示用商品数量5
    @quantity5    = params[:quantity5]
    # 表示用商品金額5
    @value5       = params[:value5]
    # 表示用商品イメージURL5
    @image_url5   = params[:image_url5]
    if @image_url5.nil?
      @image_url5 = ""
    end
    # 表示用商品説明6
    @description6 = params[:description6]
    # 表示用商品数量6
    @quantity6    = params[:quantity6]
    # 表示用商品金額6
    @value6       = params[:value6]
    # 表示用商品イメージURL6
    @image_url6   = params[:image_url6]
    if @image_url6.nil?
      @image_url6 = ""
    end
    # 表示用商品説明7
    @description7 = params[:description7]
    # 表示用商品数量7
    @quantity7    = params[:quantity7]
    # 表示用商品金額7
    @value7       = params[:value7]
    # 表示用商品イメージURL7
    @image_url7   = params[:image_url7]
    if @image_url7.nil?
      @image_url7 = ""
    end
    # 表示用商品説明8
    @description8 = params[:description8]
    # 表示用商品数量8
    @quantity8    = params[:quantity8]
    # 表示用商品金額8
    @value8       = params[:value8]
    # 表示用商品イメージURL8
    @image_url8   = params[:image_url8]
    if @image_url8.nil?
      @image_url8 = ""
    end
    # 表示用商品説明9
    @description9 = params[:description9]
    # 表示用商品数量9
    @quantity9    = params[:quantity9]
    # 表示用商品金額9
    @value9       = params[:value9]
    # 表示用商品イメージURL9
    @image_url9   = params[:image_url9]
    if @image_url9.nil?
      @image_url9 = ""
    end
    # 表示用商品説明10
    @description10 = params[:description10]
    # 表示用商品数量10
    @quantity10    = params[:quantity10]
    # 表示用商品金額10
    @value10       = params[:value10]
    # 表示用商品イメージURL10
    @image_url10   = params[:image_url10]
    if @image_url10.nil?
      @image_url10 = ""
    end

    # 合計金額
    @item_amount = params[:item_amount]

    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    #  入力パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id.nil? || @order_id.empty?
      @error_message = "<font color='#ff0000'><b>Unset Order Id<br>(必須項目：取引IDが指定されていません)</b></font><br/><br/>"
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end
    if @item_amount.nil? || @item_amount.empty?
      @error_message = "<font color='#ff0000'><b>Unset Total Amount<br>(必須項目：合計金額が指定されていません)</b></font><br/><br/>"
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 要求電文パラメータ値の指定
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::MasterpassLoginRequestDto.new
    req.order_id = @order_id.to_s
    req.item_id = @item_id.to_s
    req.item_amount = @item_amount.to_s
    req.description1 = @description1.to_s
    req.quantity1 = @quantity1.to_s
    req.value1 = @value1.to_s
    req.image_url1 = @image_url1.to_s
    req.description2 = @description2.to_s
    req.quantity2 = @quantity2.to_s
    req.value2 = @value2.to_s
    req.image_url2 = @image_url2.to_s
    req.description3 = @description3.to_s
    req.quantity3 = @quantity3.to_s
    req.value3 = @value3.to_s
    req.image_url3 = @image_url3.to_s
    req.description4 = @description4.to_s
    req.quantity4 = @quantity4.to_s
    req.value4 = @value4.to_s
    req.image_url4 = @image_url4.to_s
    req.description5 = @description5.to_s
    req.quantity5 = @quantity5.to_s
    req.value5 = @value5.to_s
    req.image_url5 = @image_url5.to_s
    req.description6 = @description6.to_s
    req.quantity6 = @quantity6.to_s
    req.value6 = @value6.to_s
    req.image_url6 = @image_url6.to_s
    req.description7 = @description7.to_s
    req.quantity7 = @quantity7.to_s
    req.value7 = @value7.to_s
    req.image_url7 = @image_url7.to_s
    req.description8 = @description8.to_s
    req.quantity8 = @quantity8.to_s
    req.value8 = @value8.to_s
    req.image_url8 = @image_url8.to_s
    req.description9 = @description9.to_s
    req.quantity9 = @quantity9.to_s
    req.value9 = @value9.to_s
    req.image_url9 = @image_url9.to_s
    req.description10 = @description10.to_s
    req.quantity10 = @quantity10.to_s
    req.value10 = @value10.to_s
    req.image_url10 = @image_url10.to_s
    if @suppress_shipping_address == 1
      req.suppress_shipping_address = "true"
    end
    req.shipping_location_profile = @shipping_location_profile.to_s
    req.success_url = @success_url.to_s
    req.cancel_url = @cancel_url.to_s
    req.error_url = @error_url.to_s

    #-------------------------------------------------------------------------
    #  実施
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)
    @response_data = res
    @request_data = req

    #--------------------------------------------------------------------------
    #レスポンスの取得
    #--------------------------------------------------------------------------

    # ログ
    puts "===== Debug Log ====="
    puts "vResultCode=" + @response_data.v_result_code

    @no_header_footer = "false"

    if @response_data.mstatus.to_s == Veritrans::Tercerog::Mdk::MdkConst::SUCCESS
      @redirect_html = res.response_contents
      if !@redirect_html.nil? && !@redirect_html.empty?
        # redirect コンテンツを返す場合、view で header/footer を表示しない
        @no_header_footer = "true"
      elsif !res.redirect_url.nil?
        redirect_to res.redirect_url, :status => 301
      end
    else
      @redirect_html = ""
    end

    @v_result_code = res.v_result_code
    @order_id = res.order_id
    @mstatus = res.mstatus
    @merr_msg = res.merr_msg

  end

end
