# -*- encoding: utf-8 -*-
class Web::Mpi::ReAuthorizeController < ApplicationController

  skip_before_action :verify_authenticity_token ,:only=>[:search, :result]

  SESSION_KEY_PAYMENT_MODE = "payment_mode".freeze

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id = "dummy" + Time.now.to_i.to_s
    @amount = params[:price].to_s
  end

  #-------------------------------------------------------------------------
  # クレジットカード決済(本人認証) 再取引要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 元取引ID
    @original_order_id = params[:original_order_id]
    # 支払金額
    @amount = params[:amount]
    # 決済種別
    @payment_mode = params[:payment_mode]
    # 与信方法
    @with_capture = params[:with_capture]
    #  支払オプション
    @jpo1=params[:jpo1]
    @jpo2=params[:jpo2]
    unless @jpo1.blank?
      if "10" == @jpo1 || "80" == @jpo1
        @jpo =  @jpo1
      elsif "61" == @jpo1 && !@jpo2.empty?
        @jpo =  @jpo1 + "C" + @jpo2
      end
    end
    #  セキュリティコード
    @security_code = params[:security_code]
    # プッシュ通知先URL
    @push_url = params[:push_url]
    # 端末種別
    @browser_device_category = params[:browser_device_category]
    # 本人認証有効期限
    @verify_timeout = params[:verify_timeout]
    # デバイスチャネル
    @device_channel = params[:device_channel]
    # アカウントタイプ
    @account_type = params[:account_type]
    # カード保有者名
    @cardholder_name = params[:cardholder_name]
    # カード保有者メールアドレス
    @cardholder_email = params[:cardholder_email]
    # カード保有者自宅電話番号国コード
    @cardholder_home_phone_country = params[:cardholder_home_phone_country]
    # カード保有者自宅電話番号
    @cardholder_home_phone_number = params[:cardholder_home_phone_number]
    # カード保有者携帯電話番号国コード
    @cardholder_mobile_phone_country = params[:cardholder_mobile_phone_country]
    # カード保有者携帯電話番号
    @cardholder_mobile_phone_number = params[:cardholder_mobile_phone_number]
    # カード保有者勤務先電話番号国コード
    @cardholder_work_phone_country = params[:cardholder_work_phone_country]
    # カード保有者勤務先電話番号
    @cardholder_work_phone_number = params[:cardholder_work_phone_number]
    # 請求先住所_市区町村
    @billing_address_city = params[:billing_address_city]
    # 請求先住所_国
    @billing_address_country = params[:billing_address_country]
    # 請求先住所1
    @billing_address_line1 = params[:billing_address_line1]
    # 請求先住所2
    @billing_address_line2 = params[:billing_address_line2]
    # 請求先住所3
    @billing_address_line3 = params[:billing_address_line3]
    # 請求先郵便番号
    @billing_postal_code = params[:billing_postal_code]
    # 請求先住所_都道府県
    @billing_address_state = params[:billing_address_state]
    # 配送先住所_市区町村
    @shipping_address_city = params[:shipping_address_city]
    # 配送先住所_国
    @shipping_address_country = params[:shipping_address_country]
    # 配送先住所1
    @shipping_address_line1 = params[:shipping_address_line1]
    # 配送先住所2
    @shipping_address_line2 = params[:shipping_address_line2]
    # 配送先住所3
    @shipping_address_line3 = params[:shipping_address_line3]
    # 配送先郵便番号
    @shipping_postal_code = params[:shipping_postal_code]
    # 配送先住所_都道府県
    @shipping_address_state = params[:shipping_address_state]
    # 消費者IPアドレス
    @customer_ip = params[:customer_ip]
    # チャレンジ認証フラグ
    @with_challenge = params[:with_challenge]
    # セッションに本人認証利用方式を格納
    session[SESSION_KEY_PAYMENT_MODE] = @payment_mode


    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @original_order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：元取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @amount == ""
      @error_message = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end

    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample

    # 本人認証利用方式を取得する。
    @mpi_payment_mode = get_mpi_payment_mode(@payment_mode)

    #-------------------------------------------------------------------------
    # ダイレクトされるURL
    #-------------------------------------------------------------------------
    @MPI_REDIRECT_URL = config["MPI"]["redirection_url2"]

    #-------------------------------------------------------------------------
    # 要求電文パラメータ値の指定
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::MpiReAuthorizeRequestDto.new
    req.service_option_type = @mpi_payment_mode.to_s
    req.order_id = @order_id.to_s
    req.original_order_id = @original_order_id.to_s
    req.amount = @amount.to_s
    req.with_capture = @with_capture.to_s
    if !@jpo.nil?
      req.jpo = @jpo.to_s
    end
    if !@security_code.nil?
      req.security_code = @security_code.to_s
    end
    if !@push_url.nil?
      req.push_url = @push_url.to_s
    end
    req.browser_device_category = @browser_device_category.to_s
    req.verify_timeout = @verify_timeout.to_s
    req.device_channel = @device_channel.to_s
    req.account_type = @account_type.to_s
    req.cardholder_name = @cardholder_name.to_s
    req.cardholder_email = @cardholder_email.to_s
    req.cardholder_home_phone_country = @cardholder_home_phone_country.to_s
    req.cardholder_home_phone_number = @cardholder_home_phone_number.to_s
    req.cardholder_mobile_phone_country = @cardholder_mobile_phone_country.to_s
    req.cardholder_mobile_phone_number = @cardholder_mobile_phone_number.to_s
    req.cardholder_work_phone_country = @cardholder_work_phone_country.to_s
    req.cardholder_work_phone_number = @cardholder_work_phone_number.to_s
    req.billing_address_city = @billing_address_city.to_s
    req.billing_address_country = @billing_address_country.to_s
    req.billing_address_line1 = @billing_address_line1.to_s
    req.billing_address_line2 = @billing_address_line2.to_s
    req.billing_address_line3 = @billing_address_line3.to_s
    req.billing_postal_code = @billing_postal_code.to_s
    req.billing_address_state = @billing_address_state.to_s
    req.shipping_address_city = @shipping_address_city.to_s
    req.shipping_address_country = @shipping_address_country.to_s
    req.shipping_address_line1 = @shipping_address_line1.to_s
    req.shipping_address_line2 = @shipping_address_line2.to_s
    req.shipping_address_line3 = @shipping_address_line3.to_s
    req.shipping_postal_code = @shipping_postal_code.to_s
    req.shipping_address_state = @shipping_address_state.to_s
    req.customer_ip = @customer_ip.to_s
    req.with_challenge = @with_challenge.to_s
    req.redirection_uri = @MPI_REDIRECT_URL.to_s
    req.http_user_agent = request.env['HTTP_USER_AGENT']
    req.http_accept = request.env['HTTP_ACCEPT']


    #-------------------------------------------------------------------------
    # 実施
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    #--------------------------------------------------------------------------
    # 想定応答の取得
    #--------------------------------------------------------------------------

    # ログ
    puts "===== Debug Log ====="
    puts "PaymentMode[" + @mpi_payment_mode + "] : vResultCode=" + res.v_result_code

    if "success" == res.mstatus.to_s
      redirect_to res.auth_start_url
    end

    # 次の画面で表示する値の設定
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
  end

  #-------------------------------------------------------------------------
  # クレジットカード決済(本人認証) 結果検索サンプル
  #-------------------------------------------------------------------------
  def search
    # リクエストID
    @request_id = params[:RequestId]
    # 決済種別
    @payment_mode = session[SESSION_KEY_PAYMENT_MODE]

    # 本人認証利用方式を取得する。
    @mpi_payment_mode = get_mpi_payment_mode(@payment_mode)


    #==========================================================================
    # 検索トランザクションの実行
    #==========================================================================
    req = Veritrans::Tercerog::Mdk::SearchRequestDto.new
    res = Veritrans::Tercerog::Mdk::SearchResponseDto.new
    req.request_id = @request_id.to_s
    req.newer_flag = "false"


    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)
    @response_data = res
    @request_data = req

    @txn_id = "";
    @mpi_txn_id = 0;
    @card_txn_id = "";

    #
    # 取引情報の取得と確認
    #
    @order_infos = @response_data.order_infos
    if @order_infos.blank?
      puts "@order_infos nil!!!!!!!!!!!!!!!!!!!!!!!!"
    end

    @order_info_list = @order_infos.order_info
    if @order_info_list.blank?
      puts "@order_info_list nil!!!!!!!!!!!!!!!!!!!!!!!!"
    end
    @target_order_id = @order_info_list[0].order_id.to_s
    if @target_order_id.blank?
      puts "@target_order_id nil!!!!!!!!!!!!!!!!!!!!!!!!"
    end

    @transaction_info_list = @response_data.order_infos.order_info[0].transaction_infos.transaction_info
    if @transaction_info_list.blank?
      puts "@transaction_info_list nil!!!!!!!!!!!!!!!!!!!!!!!!"
    end

    if @transaction_info_list.blank?
      @error_message = "Search Error Occured. （Search処理に失敗したため処理が中断されます）transaction_info"
      render :action => "index"
      return
    end

    @transaction_info_list.each do |info|

      @txn_id = info.txn_id
      puts "@txn_id ===================> " + @txn_id
      @m_status = info.mstatus
      @v_result_code = info.v_result_code
      @proper_transaction_info = info.proper_transaction_info
      # 取引種別の取得
      unless @proper_transaction_info.blank?
        @txn_kind = @proper_transaction_info.txn_kind
      end

      # 本人認証結果を取得(複数件の場合最新をチェックする)
      if @txn_id != "" && "mpi" == @txn_kind
        if @mpi_txn_id == "" || @txn_id.to_i > @mpi_txn_id.to_i
          @m_status_mpi = @m_status
          @v_result_code_mpi = @v_result_code
          @mpi_txn_id = @txn_id
        end
      end
      # カード決済結果を取得（複数件の場合最新をチェックする）
      if @txn_id != "" && "card" == @txn_kind
        if @card_txn_id == "" || @txn_id.to_i > @card_txn_id.to_i

          @m_status_card = @m_status
          @v_result_code_card = @v_result_code
          @card_txn_id = @txn_id
        end
      end
    end

    # ログ
    @v_result_code_card = "" if @v_result_code_card.nil?
    @v_result_code_mpi  = "" if @v_result_code_mpi.nil?
    puts "===== Debug Log ====="
    puts "PaymentMode[" + @mpi_payment_mode + "] : m_status_mpi = " + @m_status_mpi
    puts "  v_result_code_mpi=" + @v_result_code_mpi + ", v_result_code_card=" + @v_result_code_card

    # 取引IDとメッセージは共通
    @result_order_id = @target_order_id
    @merr_msg = res.merr_msg
    # 完了画面に表示するのは、基本、本人認証の結果
    @mstatus       = @m_status_mpi
    @v_result_code = @v_result_code_mpi

    if "success" == @m_satus_mpi
      if @mpi_payment_mode != "1"
        # 本人認証成功で、3D-Secure認証のみ(決済しない)以外の場合はカードの結果>を表示
        @mstatus       = @m_status_card
        @v_result_code = @v_result_code_card
      end
    else
    end
  end

  #-------------------------------------------------------------------------
  # クレジットカード決済 結果表示サンプル
  #-------------------------------------------------------------------------
  def result

    @error_message = ""

    @order_id = params[:OrderId]
    @request_id = params[:RequestId]
    @mpi_m_status = params[:mpiMstatus]

    conf = Veritrans::Tercerog::Mdk::MdkConfig.instance
    if !Veritrans::Tercerog::Mdk::AuthHashUtil::check_auth_hash?(\
            params.to_unsafe_h, conf.merchant_cc_id, conf.merchant_secret_key, "UTF-8")
      @error_message = "<font color='#ff0000'><b>【パラメータ改竄】パラメータ情報が改竄されています。</b></font>"
    end
  end

  private

  #-------------------------------------------------------------------------
  # 指定した決済種別に対応する本人認証利用方式を取得する。
  #-------------------------------------------------------------------------
  def get_mpi_payment_mode(payment_mode)

    #-------------------------------------------------------------------------
    # 本人認証利用方式
    #  1. 3D-Secure認証のみ（決済しない） : mpi-none
    #  2. 完全認証 : mpi-complete
    #  3. 通常認証（カード会社リスク負担） ： mpi-company
    #  4. 通常認証（カード会社、加盟店リスク負担）: mpi-merchant
    #-------------------------------------------------------------------------
    case payment_mode
      when "1"
        mpi_payment_mode = "mpi-none"
      when "2"
        mpi_payment_mode = "mpi-complete"
      when "3"
        mpi_payment_mode = "mpi-company"
      when "4"
        mpi_payment_mode = "mpi-merchant"
      else
        mpi_payment_mode = ""
    end
    return mpi_payment_mode
  end
end
