# -*- encoding: utf-8 -*-
class Web::Oricosc::Mb::AuthorizeController < ApplicationController

  layout "mb_application"
  before_action :to_utf8
  after_action :to_sjis
  skip_before_action :verify_authenticity_token

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id = "dummy" + Time.now.to_i.to_s
    @item_amount1 = params[:price].to_s
    @item_name1 = params[:item1_name].to_s
    @item_count1 = params[:item1_quantity].to_s
    @orico_order_no = @order_id
  end

  #-------------------------------------------------------------------------
  # ショッピングクレジット決済画面表示コマンド
  #-------------------------------------------------------------------------
  def execute

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 注文番号
    @orico_order_no = params[:orico_order_no]
    # 会員番号
    @user_no = params[:user_no]
    # 配送先郵便番号
    @shipping_zip_code = params[:shipping_zip_code]
    # 取扱契約番号
    @handling_contract_no = params[:handling_contract_no]
    # 契約書有無区分
    @contract_document_kbn = params[:contract_document_kbn]
    # WEB申込商品ID
    @web_description_id = params[:web_description_id]
    # 商品名１
    @item_name1 = params[:item_name1]
    # 数量１
    @item_count1 = params[:item_count1]
    # 商品価格１
    @item_amount1 = params[:item_amount1]
    # 商品名２
    @item_name2 = params[:item_name2]
    # 数量２
    @item_count2 = params[:item_count2]
    # 商品価格２
    @item_amount2 = params[:item_amount2]
    # 商品名３
    @item_name3 = params[:item_name3]
    # 数量３
    @item_count3 = params[:item_count3]
    # 商品価格３
    @item_amount3 = params[:item_amount3]
    # 商品名４
    @item_name4 = params[:item_name4]
    # 数量４
    @item_count4 = params[:item_count4]
    # 商品価格４
    @item_amount4 = params[:item_amount4]
    # 商品名５
    @item_name5 = params[:item_name5]
    # 数量５
    @item_count5 = params[:item_count5]
    # 商品価格５
    @item_amount5 = params[:item_amount5]
    # 商品価格合計(税込)
    @total_item_amount = params[:total_item_amount]
    # 送料合計
    @total_carriage = params[:total_carriage]
    # 支払金額合計
    @amount = params[:amount]
    # 頭金
    @deposit = params[:deposit]

    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      @orico_order_no = @order_id
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    #  パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @orico_order_no == ""
      @error_message = "<font color='#ff0000'><b>必須項目：注文番が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @shipping_zip_code == ""
      @error_message = "<font color='#ff0000'><b>必須項目：配送先郵便番号が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @item_name1 == ""
      @error_message = "<font color='#ff0000'><b>必須項目：商品名１が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @item_count1 == ""
      @error_message = "<font color='#ff0000'><b>必須項目：数量１が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @item_amount1 == ""
      @error_message = "<font color='#ff0000'><b>必須項目：商品価格１(税込)が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    unless isnum(@item_count1)
      @error_message = "<font color='#ff0000'><b>数量１は数値で入力しなければなりません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    unless isnum(@item_amount1)
      @error_message = "<font color='#ff0000'><b>商品価格１(税込)は数値で入力しなければなりません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @total_item_amount == ""
      @error_message = "<font color='#ff0000'><b>必須項目：商品価格合計(税込)が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    unless isnum(@total_item_amount)
      @error_message = "<font color='#ff0000'><b>商品価格合計(税込)は数値で入力しなければなりません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @amount == ""
      @error_message = "<font color='#ff0000'><b>必須項目：支払金額合計が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    unless isnum(@amount)
      @error_message = "<font color='#ff0000'><b>支払金額合計は数値で入力しなければなりません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    #-------------------------------------------------------------------------
    #  商品２～５の整合性チェック
    #-------------------------------------------------------------------------
    unless @item_name2 == ""
      if @item_count2 == ""
        @error_message = "<font color='#ff0000'><b>数量２が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_amount2 == ""
        @error_message = "<font color='#ff0000'><b>商品価格２(税込)が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_count2 == ""
      if @item_name2 == ""
        @error_message = "<font color='#ff0000'><b>商品名２が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_amount2 == ""
        @error_message = "<font color='#ff0000'><b>商品価格２(税込)が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_amount2 == ""
      if @item_name2 == ""
        @error_message = "<font color='#ff0000'><b>商品名２が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_count2 == ""
        @error_message = "<font color='#ff0000'><b>数量２が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_name3 == ""
      if @item_count3 == ""
        @error_message = "<font color='#ff0000'><b>数量３が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_amount3 == ""
        @error_message = "<font color='#ff0000'><b>商品価格３(税込)が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_count3 == ""
      if @item_name3 == ""
        @error_message = "<font color='#ff0000'><b>商品名３が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_amount3 == ""
        @error_message = "<font color='#ff0000'><b>商品価格３(税込)が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_amount3 == ""
      if @item_name3 == ""
        @error_message = "<font color='#ff0000'><b>商品名３が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_count3 == ""
        @error_message = "<font color='#ff0000'><b>数量３が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_name4 == ""
      if @item_count4 == ""
        @error_message = "<font color='#ff0000'><b>数量４が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_amount4 == ""
        @error_message = "<font color='#ff0000'><b>商品価格４(税込)が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_count4 == ""
      if @item_name4 == ""
        @error_message = "<font color='#ff0000'><b>商品名４が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_amount4 == ""
        @error_message = "<font color='#ff0000'><b>商品価格４(税込)が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_amount4 == ""
      if @item_name4 == ""
        @error_message = "<font color='#ff0000'><b>商品名４が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_count4 == ""
        @error_message = "<font color='#ff0000'><b>数量４が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_name5 == ""
      if @item_count5 == ""
        @error_message = "<font color='#ff0000'><b>数量５が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_amount5 == ""
        @error_message = "<font color='#ff0000'><b>商品価格５(税込)が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_count5 == ""
      if @item_name5 == ""
        @error_message = "<font color='#ff0000'><b>商品名５が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_amount5 == ""
        @error_message = "<font color='#ff0000'><b>商品価格５(税込)が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end
    unless @item_amount5 == ""
      if @item_name5 == ""
        @error_message = "<font color='#ff0000'><b>商品名５が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      elsif @item_count5 == ""
        @error_message = "<font color='#ff0000'><b>数量５が指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end

    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample
    @merchant_redirection_url_pc = config["ORICOSC"]["merchant_redirection_url_mb"].to_s

    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::OricoscAuthorizeRequestDto.new
    req.order_id = @order_id.to_s
    req.merchant_redirection_url = @merchant_redirection_url_pc
    req.orico_order_no = @orico_order_no
    req.user_no = @user_no
    req.item_name1 = @item_name1
    req.item_count1 = @item_count1
    req.item_amount1 = @item_amount1
    req.item_name2 = @item_name2
    req.item_count2 = @item_count2
    req.item_amount2 = @item_amount2
    req.item_name3 = @item_name3
    req.item_count3 = @item_count3
    req.item_amount3 = @item_amount3
    req.item_name4 = @item_name4
    req.item_count4 = @item_count4
    req.item_amount4 = @item_amount4
    req.item_name5 = @item_name5
    req.item_count5 = @item_count5
    req.item_amount5 = @item_amount5
    req.total_item_amount = @total_item_amount
    req.total_carriage = @total_carriage
    req.amount = @amount
    req.deposit = @deposit
    req.shipping_zip_code = @shipping_zip_code
    req.handling_contract_no = @handling_contract_no
    req.contract_document_kbn = @contract_document_kbn
    req.web_description_id = @web_description_id

    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    #------------------------------------------------------------------------
    # 結果画面に表示します。
    #------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @redirect_url = res.res_response_contents

    @process_name = "画面表示"
    @_screen = "Authorize"

    render :template => 'web/oricosc/mb/result/index'
  end


  #-------------------------------------------------------------------------
  # 数字チェック
  #-------------------------------------------------------------------------
  def isnum(num)
    unless num =~ /^[+-]?[0-9]+$/
      return false
    end
    return true
  end

  #-------------------------------------------------------------------------
  # ショッピングクレジット決済結果取得表示サンプル
  #-------------------------------------------------------------------------
  def complete
      @order_id = params[:orderId]
      @mstatus = params[:mstatus]
      @v_result_code = params[:vResultCode]
      @merr_msg = URI.decode_www_form_component((/merrMsg=(.*?)&/.match(request.headers["REQUEST_URI"].to_s))[1].to_s)
      @receipt_no = params[:receiptNo]
      @process_name = "決済結果取得"
      @_screen = "Capture"

      render :template => 'web/oricosc/mb/result/index'
  end
end
