# -*- encoding: utf-8 -*-
class Web::Paynowid::Account::WithdrawController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
  end

  #-------------------------------------------------------------------------
  # 会員退会要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 会員ID
    @account_id = params[:account_id]
    # 退会年月日
    @delete_date = params[:delete_date]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = nil
    if @account_id.nil? || @account_id.empty?
      # 会員ID
      @error_message = "<font color='#ff0000'><b>必須項目：会員IDが指定されていません</b></font>"
    end

    unless @error_message.nil?
      # エラーが存在する場合は入力画面に戻る。
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::AccountDeleteRequestDto.new
    req.account_id = @account_id.to_s
    req.delete_date = @delete_date.to_s


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    if !res.pay_now_id_response.nil?
      @pay_now_id_proc_id = res.pay_now_id_response.process_id
      @pay_now_id_status = res.pay_now_id_response.status
    end
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
  end
end
