# -*- encoding: utf-8 -*-
class Web::Paynowid::Card::AuthorizeController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id = "dummy" + Time.now.to_i.to_s
  end

  #-------------------------------------------------------------------------
  # カード選択サンプル
  #-------------------------------------------------------------------------
  def select
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 会員ID
    @account_id = params[:account_id]
    # 取引ID
    @order_id = params[:order_id]
    # 金額
    @amount = params[:amount]
    # 与信方法
    @with_capture = params[:with_capture]
    # 選択カードインデックス
    @select_card_index ||= -1

    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = nil
    if @account_id.nil? || @account_id.empty?
      # 会員ID
      @error_message = "<font color='#ff0000'><b>必須項目：会員IDが指定されていません</b></font>"

    elsif @order_id.nil? || @order_id.empty?
      # 取引ID
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font>"

    elsif @amount.nil? || @amount.empty?
      # 金額
      @error_message = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font>"
    end

    unless @error_message.nil?
      # エラーが存在する場合は入力画面に戻る。
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::CardInfoGetRequestDto.new
    req.account_id = @account_id.to_s


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @mstatus = res.mstatus
    if @mstatus == "success"
      # 成功の場合、カード選択画面に遷移
      @card_info_array = res.pay_now_id_response.account.card_info
      if @card_info_array.nil?
        @card_info_array = [Veritrans::Tercerog::Mdk::CardInfo.new]
      else
        @card_info_array << Veritrans::Tercerog::Mdk::CardInfo.new
      end

      @security_code_array = []

    else
      # それ以外の場合、決済結果画面に遷移
      @v_result_code = res.v_result_code
      @merr_msg = res.merr_msg

      if !res.pay_now_id_response.nil?
        @pay_now_id_status = res.pay_now_id_response.status
      end

      render :action => "execute"
      return
    end
  end

  #-------------------------------------------------------------------------
  # カード決済実行サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 会員ID
    @account_id = params[:account_id]
    # 取引ID
    @order_id = params[:order_id]
    # 金額
    @amount = params[:amount]
    # 与信方法
    @with_capture = params[:with_capture]
    # 支払方法
    @jpo1 = params[:jpo1]
    # 支払回数
    @jpo2 = params[:jpo2]

    # 選択カードインデックス
    @select_card_index = params[:select_card_index]
    if @select_card_index.nil? || @select_card_index.empty?
      @select_card_index = -1
    else
      @select_card_index = @select_card_index.to_i
    end

    # カード情報件数
    card_info_count = params[:card_info_count]
    # カードID
    card_id = params[:card_id]
    # カード番号
    card_number = params[:card_number]
    # 有効期限
    card_expire = params[:card_expire]
    # セキュリティコード
    security_code = params[:security_code]

    # カード情報リスト
    @card_info_array = []
    @security_code_array = []
    for index in 0..(card_info_count.to_i - 1) do
      card_info = Veritrans::Tercerog::Mdk::CardInfo.new

      if !card_id.nil?
        card_info.card_id = card_id[index.to_s].to_s
      end

      if !card_number.nil?
        card_info.card_number = card_number[index.to_s].to_s
      end

      if !card_expire.nil?
        card_info.card_expire = card_expire[index.to_s].to_s
      end

      if !security_code.nil?
        @security_code_array << security_code[index.to_s].to_s
      else
        @security_code_array << ""
      end

      if index == @select_card_index
        # 選択された行
        if index == (card_info_count.to_i - 1)
          # 最終行の場合
          selected_card_id = ""
          selected_card_number = card_info.card_number
          selected_card_expire = card_info.card_expire
          selected_security_code = @security_code_array[index]
        else
          selected_card_id = card_info.card_id
          selected_card_number = ""
          selected_card_expire = ""
          selected_security_code = @security_code_array[index]
        end
      end

      @card_info_array << card_info
    end


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = nil
    if @order_id.nil? || @order_id.empty?
      # 取引ID
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font>"

    elsif @amount.nil? || @amount.empty?
      # 金額
      @error_message = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font>"
    end

    unless @error_message.nil?
      # エラーが存在する場合は入力画面に戻る。
      render :action => "select"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::CardAuthorizeRequestDto.new
    req.account_id = @account_id.to_s
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    req.card_id = selected_card_id
    req.card_number = selected_card_number
    req.card_expire = selected_card_expire
    req.security_code = selected_security_code

    if @jpo1 == "10" || @jpo1 == "80"
      req.jpo = @jpo1.to_s
    elsif @jpo1 == "61" && !@jpo2.empty?
      req.jpo = "#{@jpo1}C#{@jpo2}"
    end

    if @with_capture == "1"
      req.with_capture = "true"
    end

    ### 標準カードフラグを設定する場合に設定（未設定時は1が設定されたものと判断） ###
    #req.default_card = "1"


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

    if !res.pay_now_id_response.nil?
      @pay_now_id_status = res.pay_now_id_response.status
    end
  end
end
