# -*- encoding: utf-8 -*-
class Web::Paypay::CaptureController < ApplicationController

  #-------------------------------------------------------------------------
  # Paypay 売上要求サンプル
  #-------------------------------------------------------------------------
  def execute

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 取引金額
    @amount = params[:amount]
    # 注文の説明
    @order_description = params[:order_description]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::PaypayCaptureRequestDto.new
    req.service_option_type = @service_option_type.to_s
    req.order_id            = @order_id.to_s
    req.amount              = @amount.to_s
    req.order_description   = @order_description.to_s
    req.service_option_type = Veritrans::Tercerog::Mdk::MdkConst::PAYPAY_ONLINE;

    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @balance = res.balance
  end
end
