# -*- encoding: utf-8 -*-
class Web::Paypay::OnlineAuthorizeController < ApplicationController

  # レスポンスコンテンツをShift-JISで返さなければならない場合の対応
  after_action :to_sjis

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id  = "dummy" + Time.now.to_i.to_s
    @amount    = params[:price].to_s

    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample

    #各種URLを取得
    @success_url = config["Paypay"]["success_url"]
    @cancel_url  = config["Paypay"]["cancel_url"]
    @error_url   = config["Paypay"]["error_url"]
    @push_url    = config["Paypay"]["push_url"]
  end

  #-------------------------------------------------------------------------
  # Paypay 与信要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 支払金額
    @amount = params[:amount]
    #商品名
    @item_name = params[:item_name]
    #商品番号
    @item_id = params[:item_id]
    #決済完了時URL
    @success_url = params[:success_url]
    #決済キャンセル時URL
    @cancel_url = params[:cancel_url]
    #決済エラー時URL
    @error_url = params[:error_url]
    #プッシュURL
    @push_url = params[:push_url]

    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    #  入力パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id.nil? || @order_id.empty?
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end
    # ダミーモード判定
    unless @push_url.nil? || @push_url.empty?
      mdk_config = Veritrans::Tercerog::Mdk::MdkConfig.instance
      unless mdk_config[:DUMMY_REQUEST] == Veritrans::Tercerog::Mdk::MdkConst::DUMMY_MODE_TRUE
          @error_message = "<font color='#ff0000'><b>プッシュURLはダミーモードのときにのみ指定可能です</b></font><br/><br/>"
          render :action => "index"
          return
      end
    end

    #-------------------------------------------------------------------------
    # 要求電文パラメータ値の指定
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::PaypayAuthorizeRequestDto.new
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    req.item_name = @item_name.to_s
    req.item_id = @item_id.to_s
    req.success_url = @success_url.to_s
    req.cancel_url = @cancel_url.to_s
    req.error_url = @error_url.to_s
    req.push_url = @push_url.to_s unless @push_url.nil?
    req.service_option_type = Veritrans::Tercerog::Mdk::MdkConst::PAYPAY_ONLINE;

    #-------------------------------------------------------------------------
    #  実施
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)
    @response_data = res
    @request_data = req

    #--------------------------------------------------------------------------
    #レスポンスの取得
    #--------------------------------------------------------------------------

    # ログ
    puts "===== Debug Log ====="
    puts "vResultCode=" + @response_data.v_result_code

    if @response_data.mstatus.to_s == Veritrans::Tercerog::Mdk::MdkConst::SUCCESS
      @redirect_html = res.response_contents
    else
      @redirect_html = ""
    end
    
    @v_result_code = res.v_result_code
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @merr_msg = res.merr_msg
  end

end
