# -*- encoding: utf-8 -*-
class Web::Rakuten::AuthorizeController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id  = "dummy" + Time.now.to_i.to_s
    @amount    = params[:price].to_s
    @item_name = params[:item_name].to_s

    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample

    #各種URLを取得
    @success_url = config["Rakuten"]["success_url"]
    @error_url   = config["Rakuten"]["error_url"]
    @push_url    = config["Rakuten"]["push_url"]
  end

  #-------------------------------------------------------------------------
  # 楽天ID決済 与信要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 支払金額
    @amount = params[:amount]
    # 決済種別
    @pay_type = params[:pay_type]
    # 与信方法
    @with_capture = params[:with_capture]
    #商品番号
    @item_id = params[:item_id]
    #商品名
    @item_name = params[:item_name]
    #決済完了時URL
    @success_url = params[:success_url]
    #決済エラー時URL
    @error_url = params[:error_url]
    #プッシュURL
    @push_url = params[:push_url]
    #課金種別
    @accounting_type = params[:accounting_type]

    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    #  入力パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id.nil? || @order_id.empty?
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end
    if (!Veritrans::Tercerog::Mdk::MdkConst::RAKUTEN_ONDEMAND.eql?(@accounting_type) && @amount.nil?) || (!Veritrans::Tercerog::Mdk::MdkConst::RAKUTEN_ONDEMAND.eql?(@accounting_type) && @amount.empty?)
      @error_message = "<font color='#ff0000'><b>必須項目：決済金額が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @item_name.nil? || @item_name.empty?
      @error_message = "<font color='#ff0000'><b>必須項目：商品名が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 要求電文パラメータ値の指定
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::RakutenAuthorizeRequestDto.new
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    req.pay_type = @pay_type.to_s
    req.with_capture = @with_capture.to_s

    req.item_id = @item_id.to_s
    req.item_name = @item_name.to_s
    req.success_url = @success_url.to_s
    req.error_url = @error_url.to_s
    req.push_url = @push_url.to_s unless @push_url.nil?
    req.accounting_type = @accounting_type.to_s

    #-------------------------------------------------------------------------
    #  実施
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)
    @response_data = res
    @request_data = req

    #--------------------------------------------------------------------------
    #レスポンスの取得
    #--------------------------------------------------------------------------

    # ログ
    puts "===== Debug Log ====="
    puts "vResultCode=" + @response_data.v_result_code

    @no_header_footer = "false"
    if @response_data.mstatus.to_s == Veritrans::Tercerog::Mdk::MdkConst::SUCCESS
      @redirect_html = res.response_contents
      if !@redirect_html.nil? && !@redirect_html.empty?
        # redirect コンテンツを返す場合、view で header/footer を表示しない
        #@no_header_footer = is_no_header_footer
        @no_header_footer = "true"
      elsif !res.redirect_url.nil?
        redirect_to res.redirect_url, :status => 301
      end
    else
      @redirect_html = ""
    end

    @v_result_code = res.v_result_code
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @merr_msg = res.merr_msg
  end
end
