# -*- encoding: utf-8 -*-
class Web::Rakuten::CancelController < ApplicationController

  #-------------------------------------------------------------------------
  # 楽天ID決済 取消要求サンプル
  #-------------------------------------------------------------------------
  def execute

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 取引金額
    @amount = params[:amount]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::RakutenCancelRequestDto.new
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @cancel_datetime = res.cancel_req_datetime
    @balance = res.balance
    @transaction_datetime = res.transaction_datetime
    @rakuten_order_id = res.rakuten_order_id
    @gateway_order_id = res.gateway_order_id
    @used_point = res.used_point

  end
end
