# -*- encoding: utf-8 -*-
class Web::Rakuten::ReAuthorizeController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id  = "dummy" + Time.now.to_i.to_s
  end

  #-------------------------------------------------------------------------
  # 楽天ID決済再与信要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 元取引ID
    @original_order_id = params[:original_order_id]
    # 金額
    @amount = params[:amount]
    # 与信方法
    @with_capture = params[:with_capture]
    #商品ID
    @item_id = params[:item_id]
    #商品名
    @item_name = params[:item_name]

    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    #  必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id.nil? || @order_id.empty?
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end
    if @original_order_id.nil? || @original_order_id.empty?
      @error_message = "<font color='#ff0000'><b>必須項目：元取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @amount.nil? || @amount.empty?
      @error_message = "<font color='#ff0000'><b>必須項目：決済金額が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::RakutenReAuthorizeRequestDto.new
    req.order_id = @order_id.to_s
    req.original_order_id = @original_order_id.to_s
    req.amount = @amount.to_s
    req.with_capture = @with_capture.to_s
    req.item_id = @item_id.to_s
    req.item_name = @item_name.to_s

    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @original_order_id = res.original_order_id
    @rakuten_order_id = res.rakuten_order_id
    @gateway_order_id = res.gateway_order_id
    @rakuten_consent_order_id = res.rakuten_consent_order_id
    @customer_id = res.customer_id
    @used_point = res.used_point
    @card_brand = res.card_brand
    @card_last4 = res.card_last4
    @card_installments = res.card_installments
    @card_cvc = res.card_cvc
    @card_3ds = res.card3ds
    @transaction_datetime = res.transaction_datetime
    @cancel_expiration_time = res.cancel_expiration_time
    @capture_expiration_time = res.capture_expiration_time
    @update_expiration_time = res.update_expiration_time
    @extend_auth_expiration_time = res.extend_auth_expiration_time
  end
end
