# -*- encoding: utf-8 -*-
class Web::Saison::CancelController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @card_cancel_flag ||= '1'
  end

  #-------------------------------------------------------------------------
  # Saison決済 取消要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # カード取消フラグ
    @card_cancel_flag = params[:card_cancel_flag]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::SaisonCancelRequestDto.new
    req.order_id = @order_id.to_s
    req.card_cancel_flag = @card_cancel_flag


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    #------------------------------------------------------------------------
    # 結果画面に表示します。
    #------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

    @card_order_id = res.card_order_id
    @card_mstatus = res.card_mstatus
    @card_v_result_code = res.card_v_result_code
    @card_merr_msg = res.card_merr_msg
    @req_card_number = res.req_card_number
    @res_auth_code = res.res_auth_code

    @process_name = "取消"
    @_screen = "Cancel"

    render :template => 'web/saison/result/index'
  end
end
