# -*- encoding: utf-8 -*-
class Web::Saison::Mb::AuthorizeController < Web::Saison::AuthorizeController
  layout "mb_application"
  before_action :to_utf8
  after_action :to_sjis
  skip_before_action :verify_authenticity_token

  #-------------------------------------------------------------------------
  # Saison決済 与信要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 金額
    @amount = params[:amount]


    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @amount == ""
      @error_message = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    unless @amount =~ /^[+-]?[0-9]+$/
      @error_message = "<font color='#ff0000'><b>金額は数値で入力しなければなりません</b></font><br/><br/>"
      render :action => "index"
      return
    end

    Rails.cache.write('amount', @amount)

    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample

    merchant_redirection_uri = config["SAISON"]["merchant_redirection_uri_mb"].to_s
    settlement_method = "MB"


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::SaisonAuthorizeRequestDto.new
    req.order_id = @order_id.to_s
    req.merchant_redirection_uri = merchant_redirection_uri
    req.settlement_method = settlement_method


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    if "success" == res.mstatus then
      #------------------------------------------------------------------------
      # ダミー画面へ
      #------------------------------------------------------------------------
      redirect_to res.res_response_contents, :status => 301

    else
      #------------------------------------------------------------------------
      # 結果画面に表示します。
      #------------------------------------------------------------------------
      @result_order_id = res.order_id
      @mstatus = res.mstatus
      @v_result_code = res.v_result_code
      @merr_msg = res.merr_msg

      @process_name = "与信"
      @_screen = "Authorize"

      render :template => 'web/saison/mb/result/index'
    end
  end
end
