# -*- encoding: utf-8 -*-
class Web::Upop::RefundController < ApplicationController
  include MdkValidation

  #-------------------------------------------------------------------------
  # UPOP返金サンプル
  #-------------------------------------------------------------------------
  def execute

    @err_msg = validate_upop_capture
    unless @err_msg.blank?
      render :action => :index
    return
    end

    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::UpopRefundRequestDto.new
    req.order_id = params[:orderId].to_s
    req.amount = params[:amount].to_s

    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    if @mstatus.eql?('success')
      @cust_txn = res.cust_txn
      @merch_txn = res.march_txn
      @captured_amt = res.captured_amount
      @remaining_amt = res.remaining_amount
      @settle_amount = res.settle_amount
      @settle_currency = res.settle_currency
      @settle_date = res.settle_date
      @txn_datetime_cn = res.txn_datetime_cn
      @txn_datetime_jp = res.txn_datetime_jp
      @settle_rate = res.settle_rate
      @upop_order_id = res.upop_order_id
    end
  end
end
