# -*- encoding: utf-8 -*-
class Web::Virtualacc::AuthorizeController < ApplicationController

  # set_dummy_request を実行する
  # after_action では render の後に実行されるため
  before_action :set_dummy_request

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id  = "dummy" + Time.now.to_i.to_s
    @amount    = params[:price].to_s
    @entry_transfer_name    = params[:entry_transfer_name].to_s
    @entry_transfer_number  = params[:entry_transfer_number].to_s
    @transfer_expired_date  = params[:transfer_expired_date].to_s
    @account_manage_type    = params[:account_manage_type].to_s
    @branch_code            = params[:branch_code].to_s
    @account_number         = params[:account_number].to_s
    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample
  end

  #-------------------------------------------------------------------------
  # before_action で実行されるメソッド
  #-------------------------------------------------------------------------
  def set_dummy_request
    # ダミーモード判定
    mdk_config = Veritrans::Tercerog::Mdk::MdkConfig.instance
    @dummy_request = mdk_config[:DUMMY_REQUEST]
  end

  #-------------------------------------------------------------------------
  # 銀行振込決済 決済申込要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 支払金額
    @amount = params[:amount]
    # 登録時振込人名
    @entry_transfer_name = params[:entry_transfer_name]
    # 登録時振込番号
    @entry_transfer_number = params[:entry_transfer_number]
    # 振込期限
    @transfer_expired_date = params[:transfer_expired_date]
    # 口座管理方式
    @account_manage_type = params[:account_manage_type]
    # 支店コード
    @branch_code = params[:branch_code]
    # 口座番号
    @account_number = params[:account_number]

    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    #  入力パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id.nil? || @order_id.empty?
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end
    if @amount.nil? || @amount.empty?
      @error_message = "<font color='#ff0000'><b>必須項目：決済金額が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 要求電文パラメータ値の指定
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::VirtualaccAuthorizeRequestDto.new
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    req.entry_transfer_name = @entry_transfer_name.to_s
    req.entry_transfer_number = @entry_transfer_number.to_s
    req.transfer_expired_date = @transfer_expired_date.to_s
    req.account_manage_type = @account_manage_type.to_s
    req.account_number = @account_number.to_s
    req.branch_code = @branch_code.to_s
    req.service_option_type = Veritrans::Tercerog::Mdk::MdkConst::VACC_RESONA
    
    #-------------------------------------------------------------------------
    #  実施
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)
    @response_data = res
    @request_data = req

    #--------------------------------------------------------------------------
    #レスポンスの取得
    #--------------------------------------------------------------------------

    # ログ
    puts "===== Debug Log ====="
    puts "vResultCode=" + @response_data.v_result_code

    @v_result_code = res.v_result_code
    @result_order_id = res.order_id
    @transfer_name = res.transfer_name
    @bank_name = res.bank_name
    @bank_code = res.bank_code
    @branch_name = res.branch_name
    @branch_code = res.branch_code
    @account_type = res.account_type
    @account_name = res.account_name
    @account_number = res.account_number
    @mstatus = res.mstatus
    @merr_msg = res.merr_msg
  end

end
